package FLAGS;
use strict;
use warnings;

use constant;
use Exporter;

our @EXPORT_OK;
my %flags;

################################################################################
sub import
{
    my($class, @flags) = @_;
    foreach(@flags)
    {
        unless(exists $flags{$_})
        {
            FLAGS->SET($_, undef);
        }
    }
    goto &Exporter::import;
}
################################################################################
sub SET
{
    my $class = shift;
    my %set;
    if ( ref $_[0] )
    {
        %set = %{ $_[0] };
    }
    else
    {
        %set = @_;
    }

    foreach ( keys %set )
    {
        if ( exists $flags{$_} )
        {
            if ( defined $flags{$_} && defined $set{$_} && $flags{$_} eq $set{$_} )
            {
                delete $set{$_};
            }
            elsif ( !defined $flags{$_} && !defined $set{$_} )
            {
                delete $set{$_};
            }
            else
            {
                die "Flag [$_] set in 2 unmatched value: [$flags{$_}] and [$set{$_}]";
            }
        }
        else
        {
            $flags{$_} = $set{$_};
            push @EXPORT_OK, $_;
        }
    }

    __PACKAGE__->constant::import( \%set );
}
################################################################################
1;
